Skip to content
API Reference

List providers

client.Zones.Providers.List(ctx, zoneID, query) (*ZoneProviderListResponse, error)
GET/zones/{zoneId}/providers

Returns a list of providers in the specified zone

ParametersExpand Collapse
zoneID string
query ZoneProviderListParams
After param.Field[string]optional

Cursor for forward pagination

minLength1
maxLength255
Before param.Field[string]optional

Cursor for backward pagination

minLength1
maxLength255
Cursor param.Field[string]optional
Expand param.Field[ZoneProviderListParamsExpandUnion]optional
type ZoneProviderListParamsExpandString string
type ZoneProviderListParamsExpandArray []string
Identifier param.Field[string]optional
Limit param.Field[int64]optional

Maximum number of items to return

minimum1
maximum100
Slug param.Field[string]optional
Type param.Field[ZoneProviderListParamsType]optional
const ZoneProviderListParamsTypeExternal ZoneProviderListParamsType = "external"
const ZoneProviderListParamsTypeKeycardVault ZoneProviderListParamsType = "keycard-vault"
const ZoneProviderListParamsTypeKeycardSts ZoneProviderListParamsType = "keycard-sts"
ReturnsExpand Collapse
type ZoneProviderListResponse struct{…}
Items []Provider
ID string

Unique identifier of the provider

CreatedAt Time

Entity creation timestamp

formatdate-time
Identifier string

User specified identifier, unique within the zone

minLength1
maxLength2048
Name string

Human-readable name

minLength1
maxLength255
OrganizationID string

Organization that owns this provider

OwnerType ProviderOwnerType

Who owns this provider. Platform-owned providers cannot be modified via API.

Accepts one of the following:
const ProviderOwnerTypePlatform ProviderOwnerType = "platform"
const ProviderOwnerTypeCustomer ProviderOwnerType = "customer"
Slug string

URL-safe identifier, unique within the zone

minLength1
maxLength63
UpdatedAt Time

Entity update timestamp

formatdate-time
ZoneID string

Zone this provider belongs to

ClientID stringoptional

OAuth 2.0 client identifier

ClientSecretSet booloptional

Indicates whether a client secret is configured

Description stringoptional

Human-readable description

maxLength2048
Metadata anyoptional

Provider metadata

Protocols ProviderProtocolsoptional

Protocol-specific configuration

Oauth2 ProviderProtocolsOauth2optional

OAuth 2.0 protocol configuration

Issuer string

OIDC issuer URL used for discovery and token validation.

formaturi
AuthorizationEndpoint stringoptional
formaturi
AuthorizationParameters map[string, string]optional

Custom query parameters appended to authorization redirect URLs. Use for non-standard providers (e.g. Google prompt=consent, access_type=offline).

AuthorizationResourceEnabled booloptional

Whether to include the resource parameter in authorization requests.

AuthorizationResourceParameter stringoptional

The resource parameter value to include in authorization requests. Defaults to "resource" when authorization_resource_enabled is true.

CodeChallengeMethodsSupported []stringoptional
JwksUri stringoptional
formaturi
RegistrationEndpoint stringoptional
formaturi
ScopeParameter stringoptional

The query parameter name for scopes in authorization requests. Defaults to "scope". Slack v2 uses "user_scope".

ScopeSeparator stringoptional

The separator character for scope values. Defaults to " " (space). Slack v2 uses ",".

ScopesSupported []stringoptional
TokenEndpoint stringoptional
formaturi
TokenResponseAccessTokenPointer stringoptional

Dot-separated path to the access token in the token response body. Defaults to "access_token". Slack v2 uses "authed_user.access_token".

Openid ProviderProtocolsOpenidoptional

OpenID Connect protocol configuration

UserinfoEndpoint stringoptional
formaturi
Type ProviderTypeoptional
Accepts one of the following:
const ProviderTypeExternal ProviderType = "external"
const ProviderTypeKeycardVault ProviderType = "keycard-vault"
const ProviderTypeKeycardSts ProviderType = "keycard-sts"

Pagination information

HasNextPage bool

Whether there are more items after the current page

HasPreviousPage bool

Whether there are items before the current page

EndCursor stringoptional

Cursor pointing to the last item in the current page

StartCursor stringoptional

Cursor pointing to the first item in the current page

List providers

package main

import (
  "context"
  "fmt"

  "github.com/keycardai/keycard-go"
)

func main() {
  client := keycard.NewClient(

  )
  providers, err := client.Zones.Providers.List(
    context.TODO(),
    "zoneId",
    keycard.ZoneProviderListParams{

    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", providers.Items)
}
{
  "items": [
    {
      "id": "id",
      "created_at": "2019-12-27T18:11:19.117Z",
      "identifier": "x",
      "name": "x",
      "organization_id": "organization_id",
      "owner_type": "platform",
      "slug": "slug",
      "updated_at": "2019-12-27T18:11:19.117Z",
      "zone_id": "zone_id",
      "client_id": "client_id",
      "client_secret_set": true,
      "description": "description",
      "metadata": {},
      "protocols": {
        "oauth2": {
          "issuer": "https://example.com",
          "authorization_endpoint": "https://example.com",
          "authorization_parameters": {
            "foo": "string"
          },
          "authorization_resource_enabled": true,
          "authorization_resource_parameter": "authorization_resource_parameter",
          "code_challenge_methods_supported": [
            "string"
          ],
          "jwks_uri": "https://example.com",
          "registration_endpoint": "https://example.com",
          "scope_parameter": "scope_parameter",
          "scope_separator": "scope_separator",
          "scopes_supported": [
            "string"
          ],
          "token_endpoint": "https://example.com",
          "token_response_access_token_pointer": "token_response_access_token_pointer"
        },
        "openid": {
          "userinfo_endpoint": "https://example.com"
        }
      },
      "type": "external"
    }
  ],
  "page_info": {
    "has_next_page": true,
    "has_previous_page": true,
    "end_cursor": "end_cursor",
    "start_cursor": "start_cursor"
  },
  "pagination": {
    "after_cursor": "x",
    "before_cursor": "x",
    "total_count": 0
  }
}
Returns Examples
{
  "items": [
    {
      "id": "id",
      "created_at": "2019-12-27T18:11:19.117Z",
      "identifier": "x",
      "name": "x",
      "organization_id": "organization_id",
      "owner_type": "platform",
      "slug": "slug",
      "updated_at": "2019-12-27T18:11:19.117Z",
      "zone_id": "zone_id",
      "client_id": "client_id",
      "client_secret_set": true,
      "description": "description",
      "metadata": {},
      "protocols": {
        "oauth2": {
          "issuer": "https://example.com",
          "authorization_endpoint": "https://example.com",
          "authorization_parameters": {
            "foo": "string"
          },
          "authorization_resource_enabled": true,
          "authorization_resource_parameter": "authorization_resource_parameter",
          "code_challenge_methods_supported": [
            "string"
          ],
          "jwks_uri": "https://example.com",
          "registration_endpoint": "https://example.com",
          "scope_parameter": "scope_parameter",
          "scope_separator": "scope_separator",
          "scopes_supported": [
            "string"
          ],
          "token_endpoint": "https://example.com",
          "token_response_access_token_pointer": "token_response_access_token_pointer"
        },
        "openid": {
          "userinfo_endpoint": "https://example.com"
        }
      },
      "type": "external"
    }
  ],
  "page_info": {
    "has_next_page": true,
    "has_previous_page": true,
    "end_cursor": "end_cursor",
    "start_cursor": "start_cursor"
  },
  "pagination": {
    "after_cursor": "x",
    "before_cursor": "x",
    "total_count": 0
  }
}